--[[ CLASS ]]--

local Game = class("Game")
Game:include(Stateful)

Game.static.camSpeed = 400

function Game:initialize()
	self:gotoState("Menu")
end

function Game:update() end
function Game:draw() end
function Game:textinput() end
function Game:mousepressed() end
function Game:mousereleased() end
function Game:keypressed() end
function Game:keyreleased() end


--[[ STATES ]]--

	--// Menu State //--

	local Menu = Game:addState("Menu")

	function Menu:enteredState()
		local interface = gui.Interface:new(self):loadFromFile("menu/main")
	end

	function Menu:draw()

	end

	function Menu:exitedState()
		loveframes.util.RemoveAll()
	end


	--// Play State //--

	local Play = Game:addState("Play")

	function Play:enteredState()
		self.map = sti.new("maps/test")
		self.cam = gamera.new(0, 0, self.map.width * self.map.tilewidth, self.map.height * self.map.tileheight)
		self.cam._velX = 0
		self.cam._velY = 0
	end

	function Play:draw()
		self.cam:draw(function(l, t, w, h)
			self.map:setDrawRange(-l, -t, w, h)
			self.map:draw()
		end)
	end

	local isDown = love.keyboard.isDown
	local areDown = love.keyboard.areDown
	function Play:update(dt)
		self.map:update(dt)

		local x, y, w, h = self.cam:getVisible()

		-- Current Position
		local camX, camY = self.cam:getPosition()

		if not areDown("a", "d") then
			if isDown("a") then
				self.cam:setPosition(camX - Game.camSpeed * dt, camY)
			elseif isDown("d") then
				self.cam:setPosition(camX + Game.camSpeed * dt, camY)
			end
		end

		local camX, camY = self.cam:getPosition()

		if not areDown("w", "s") then
			if isDown("w") then
				self.cam:setPosition(camX, camY - Game.camSpeed * dt)
			elseif isDown("s") then
				self.cam:setPosition(camX, camY + Game.camSpeed * dt)
			end
		end
	end

	function Play:keypressed(key, isRepeat)
		local x, y = self.cam:getPosition()
	end



return Game