io.stdout:setvbuf("no")

love.graphics.setLineWidth(1)
love.graphics.setDefaultFilter("nearest", "nearest")

function love.keyboard.areDown(...)
   for index, key in pairs({...}) do
      if (not love.keyboard.isDown(key)) then
         return false
      end
   end
   
   return true
end

-- Libraries
bump		=	require "lib.bump"
class 		= 	require "lib.middleclass"
gamera		=	require "lib.gamera"
gui			=	require "lib.gui"
inspect 	= 	require "lib.inspect"
loveframes 	= 	require "lib.loveframes"
math		=	require "lib.math"
ser			=	require "lib.ser"
Stateful 	= 	require "lib.stateful"
sti			=	require "lib.sti"

-- Classes
Game	=	require "game"

local game
function love.load()
	game = Game:new()
end

function love.update(dt)
	game:update(dt)
	loveframes.update(dt)
end

function love.draw()
	game:draw()
	loveframes.draw()
end

function love.mousepressed(x, y, button)
	game:mousepressed(x, y, button)
    loveframes.mousepressed(x, y, button)

end

function love.mousereleased(x, y, button)
	game:mousereleased(x, y, button)
    loveframes.mousereleased(x, y, button)

end

function love.keypressed(key, isRepeat)
	game:keypressed(key, isRepeat)
	loveframes.keypressed(key, unicode)
end

function love.keyreleased(key)
	game:keypressed(key, isRepeat)
    loveframes.keyreleased(key)

end

function love.textinput(text)
	loveframes.textinput(text)
end